/* contaClient.c */

#include <stdio.h>
#include <rpc/rpc.h>
#include "conta.h"

main(int argc,char *argv[])
{

  CLIENT *clnt;  /*gestore di protocollo*/

  int *ris;
  char *server;
  char *nomeInput;
  Input input;
  char car, ok[5];


  nomeInput=(char*)malloc(50);
  input.nomeFile=(char*)malloc(50);


  if(argc !=2)
  {
    fprintf(stderr,"uso: %s nomehost\n",argv[0]);
    exit(1);
  }

  clnt=clnt_create(argv[1],CONTAPROG,CONTAVERS,"udp");

  if(clnt == NULL)
  {
    clnt_pcreateerror(argv[1]);
    exit(1);
  }

  printf("richieste servizio fino a fine file\n");
  printf("operazioni:  CC=Conta Carattere, CF=Conta File\n");

  while(gets(ok))
  {
    while( (strcmp(ok, "CC")!=0) && (strcmp(ok, "CF")!=0) )
    {
	  printf("richieste servizio fino a fine file\n");
      printf("operazioni:  CC=Conta Carattere, CF=Conta File\n");
      continue;
    }

	printf("Richiesto servizio: %s\n", ok);

    // richiesta conteggio caratteri
    if( strcmp(ok, "CC")==0 )
    {
      printf("inserisci il nome file: \n");
      gets(nomeInput);
      printf("inserisci il carattere che vuoi contare: \n");
      car=getchar();
      // consumo il fine linea
      gets(ok);  // usato come buffer da scartare

      strcpy(input.nomeFile, nomeInput);
      input.car=car;

      ris=conta_carattere_1(&input,clnt);

      if(ris==(int *)NULL)
      {
        clnt_perror(clnt,"call failed");
      }
      else if(*ris==-1)
      {
        printf("E' avvenuto un errore lato server\n");
      }
      else
      {
        printf("Ho contato %d caratteri!\n",*ris);
      }
    }// CC

    // richiesta conteggio file nel direttorio remoto
    if( strcmp(ok, "CF")==0 )
    {
      printf("inserisci il nome del direttorio remoto: \n");
      gets(nomeInput);

      ris=conta_file_1(&nomeInput,clnt);

      if(ris==(int *)NULL)
      {
        clnt_perror(clnt,"call failed");
      }
      else if(*ris==-1)
      {
        printf("E' avvenuto un errore lato server\n");
      }
      else
      {
        printf("Ho contato %d file!\n",*ris);
      }
    }// CF
	  printf("richieste servizio fino a fine file\n");
      printf("operazioni:  CC=Conta Carattere, CF=Conta File\n");

  } //while

  clnt_destroy(clnt);
  free(nomeInput);
  printf("Esco dal client");

}

