/* contaServer.c */

#include <stdio.h>
#include <rpc/rpc.h>
#include <sys/types.h>
#include <unistd.h>
#include <dirent.h>
#include <fcntl.h>

#include "conta.h"

int *conta_carattere_1_svc (Input *input, struct svc_req *rp)
{
  static int result=0;
  int fd_file, nread;
  char cCorr;

  result=-1;

  printf("Richiesto file %s\n", input->nomeFile);

  fd_file=open(input->nomeFile, O_RDONLY);
  if (fd_file<0)
  {printf("File inesistente\n"); return (&result);}
  else
  {
	result=0;
    /* Conteggio caratteri */
    while((nread=read(fd_file, &cCorr, 1))>0)
    {
  	  if (cCorr==input->car) result++;
    }
    printf("Ho letto %d caratteri\n", result);
    /* restituisco il risultato */
    return (&result);
  }//else

}


int *conta_file_1_svc (char **input, struct svc_req *rp)
{
  static int result=0;
  DIR* dir;
  struct dirent * dd;

  result=-1;

  printf("Richiesto direttorio %s\n", *input);
  if((dir = opendir (*input))==NULL) return (&result);

  result = 0;
  while ((dd = readdir(dir)) != NULL)
  {
    if( (strcmp(dd->d_name, ".")!=0) && (strcmp(dd->d_name, "..")!=0) ) result++;
  }
  printf("Numero totale di file nel direttorio richiesto %d\n", result);

  return (&result);
}


